



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>设计一个 硬件 实现的 Dictionary（字典）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">设计一个 硬件 实现的 Dictionary（字典）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 23:02:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Dictionary 就是 字典， 是一种可以根据 Key 来 快速 查找 Value 的 数据结构 。</p>
<p>比如 我们在 C# 里用到的 Dictionary&lt;T&gt;，</p>
<p>在 程序设计 里， 字典 通常使用 哈希表（Hash 表） 的 方式 实现， 也可以用 索引 的 方式 实现，</p>
<p>不过 索引 太占空间 了，&nbsp; 所以 在 数据库 里 用的 很普遍， 但是 在 应用程序（内存） 这一层面 好像 没有看到过用 索引 的 。</p>
<p>今天 我们 来 设计一个 用 硬件 实现 的 字典 ：&nbsp; &nbsp; &nbsp; ^^</p>
<p>要开始研究 硬件 来 实现一个 字典 呢， 需要 先 准备 一些 基础知识， 可以先看一下我写的另外一篇文章&nbsp; 《漫谈计算机硬件的设计和实现》</p>
<p><a href="https://www.cnblogs.com/KSongKing/p/9866334.html" rel="external nofollow noreferrer">https://www.cnblogs.com/KSongKing/p/9866334.html</a></p>
<p>首先， 我们要引入一个 &ldquo;开关门&rdquo; 门电路， 就是 除了 &ldquo;与&rdquo;、&ldquo;或&rdquo;、&ldquo;非&rdquo;&nbsp; 门电路 外， 还需要一个 &ldquo;开关门&rdquo; 门电路，</p>
<p>实际上， &ldquo;开关门&rdquo; 电路 就是 构成&nbsp;&ldquo;与&rdquo;、&ldquo;或&rdquo;、&ldquo;非&rdquo;&nbsp; 门电路 的 基础 。</p>
<p>我们来看一下&nbsp; &ldquo;开关门&rdquo; 电路 的 逻辑电路图 ：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1388256/201812/1388256-20181228220900819-481486394.png" /></p>
<p>当 控制端 输入 0 时， 开关 关， 即 输入端 到 输出端 之间的 电路 断开，</p>
<p>当 控制端 输入 1 时， 开关 开， 即 输入端 到 输出端 之间的 电路 接通 。</p>
<p>这个 &ldquo;开关门 &rdquo;&nbsp; 是不是有点像 三极管 ？&nbsp; &nbsp;哈哈哈</p>
<p>接下来， 我们要设计一个&nbsp; &ldquo;电子开关&rdquo;，</p>
<p>&ldquo;电子开关&rdquo; 就是</p>
<p>当 设定端 是 0 时， 输入端 若 输入 0 ， 则 输出端 输出 1， 若 输入端 输入 1 时， 输出端 输入 0，</p>
<p>当&nbsp;设定端 是 1 时， 输入端 若 输入 0 ， 则 输出端 输出 0， 若 输入端 输入 1 时， 输出端 输入 1，</p>
<p>这是&nbsp; &hellip;&hellip;&nbsp; ？</p>
<p>哈哈哈，&nbsp; 就是 输入端 输入的 值 和 设定端 相同 时， 输出端 输出 1 （开），&nbsp; 否则 输出端 输出 0 （关） 。</p>
<p>这有什么用&nbsp; ？</p>
<p>利用 这个&nbsp; &ldquo;设定&rdquo; 的 功能， 可以实现&nbsp; &ldquo;设置 Key&rdquo;&nbsp; 的 效果 。</p>
<p>我们来看一下 &ldquo;电子开关&rdquo; 的 逻辑电路图 ：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1388256/201812/1388256-20181228222434646-436209073.png" /></p>
<p>有了 &ldquo;电子开关&rdquo;，&nbsp; 我们 就可以 实现一个 &ldquo;字典单元&rdquo;，&nbsp; 一个 &ldquo;字典单元&rdquo; 可以 存放 一个 键值对 。</p>
<p>我们来看一下 &ldquo;字典单元&rdquo; 的 逻辑电路图 ：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1388256/201812/1388256-20181228223011915-41018419.png" /></p>
<p>简单起见， 上图的这个 字典单元 只有&nbsp; 2 位（2 Bit），&nbsp; 就是说 可以支持&nbsp; &nbsp;&ldquo;00&rdquo;、&ldquo;01&rdquo;、&ldquo;10&rdquo;、&ldquo;11&rdquo;&nbsp; &nbsp;4 个 键 。</p>
<p>在 设定端 可以 设定键，&nbsp; 比如 设定端 是&nbsp; &ldquo;00&rdquo;，&nbsp; &nbsp;则 输入端 输入 &ldquo;00&rdquo; 时，&nbsp; 最上方 的 &ldquo;与门&rdquo; 输出 1 ，&nbsp; &ldquo;Value 存储单元&rdquo; 接通， 可以读取数据， 读取到的就是 键 对应的 值 。 输入端 输入 非 &ldquo;00&rdquo; 的 其它 值 时，&nbsp; 与门 输出 0，&nbsp; &ldquo;Value 存储单元&rdquo; 不接通，&nbsp; 不能读取数据 。</p>
<p>又比如&nbsp;设定端 是&nbsp; &ldquo;01&rdquo;，&nbsp; &nbsp;则 输入端 输入 &ldquo;01&rdquo; 时，&nbsp; 最上方 的 &ldquo;与门&rdquo; 输出 1 ，&nbsp; &ldquo;Value 存储单元&rdquo; 接通， 可以读取数据， 读取到的就是 键 对应的 值 。&nbsp;输入端 输入 非 &ldquo;01&rdquo; 的 其它 值 时，&nbsp; 与门 输出 0，&nbsp;&nbsp;&ldquo;Value 存储单元&rdquo; 不接通，&nbsp; 不能读取数据 。</p>
<p>这就实现了一个 字典单元，</p>
<p>我们把 若干个 字典单元 并联起来（按引脚并联）， 即 设定端 的 引脚 1 和 引脚 1 并联， 引脚 2 和 引脚 2 并联 &hellip;&hellip;&nbsp; 输入端， 输出端 亦然 。</p>
<p>这样 就 组成了一个 字典， 或者说 字典阵列， 就像 内存 的 一组 存储单元 一样 。</p>
<p>n 个 字典单元 组成 的 字典阵列 可以 存放 n 个 键值对 。</p>
<p>哎 ？&nbsp; &nbsp;等，，，&nbsp; 说到&nbsp; &nbsp;&ldquo;阵列&rdquo;&nbsp; ，&nbsp; 如果 设定端 在 断电 的 情况下 也能 保存 设定值，&nbsp; 那这岂不就成了&nbsp; &nbsp;&ldquo;可编程逻辑阵列&rdquo;&nbsp; &nbsp; 了嘛&nbsp; ~！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q77m1xq.html">WebUploader UEditor chrome 点击上传文件选择框会延迟几秒才会显示 反应很慢</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlknee8.html">Redmine CodeReview</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gwm278.html">&lbrack;ThingWorx&rsqb; Install PostgreSQL Issue</a>
		</li>
						<li><a href="https://www.batexi.com/a/495o7ov8.html">webpack处理非模块化的几方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd6g12q.html">ASP&period;NET中页面加载时文本框&lpar;texbox控件&rpar;内有文字获得焦点时文字消失</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm715x9.html">Android 发送HTTP GET POST 请求以及通过 MultipartEntityBuilder 上传文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1y3379.html">MFC窗口的父子关系和层级关系</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1krrwz9.html">bootstrap标准模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jnd0l8.html">10位时间戳转为C&num;格式时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp165xq.html">tarjan&mdash;&mdash;cogs 1298 通讯问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp367j9.html">sping&lowbar;依赖注入的三种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25wnpxq.html">创建一个dynamics 365 CRM online plugin &lpar;四&rpar; - PreValidation</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w7v2zq.html">css 子盒子上下居中 文字溢出省略号</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kj7plq.html">DbScopeFactory</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4dwmpq.html">jfinal的model和record如何相互转化？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qver67y9.html">hook进程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjk5yxq.html">POJ1556 最短路 &plus; 线段相交问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvepkg19.html">Mysql数据库中InnoDB和MyISAM的差别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkpm3v8.html">RabbitMQ的安装和使用Python连接RabbitMQ</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1gl019.html">libiop通讯流程和api讲解</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qll4oo0q.html">Gym - 100971J （思维&plus;简单bfs）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2lzox9.html">ubuntu Cairo图形库 环境搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rge0j9.html">python 正则进阶</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5x1p7q.html">git 服务器安装流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7orgyg8.html">2--Python入门--Python数据集合类型--列表</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wz7vzq.html">LazyMan的实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1r34x28.html">easyUI 下拉组件转义</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2ljoy9.html">精确率、召回率、准确率与ROC曲线</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll4wgeq.html">深度强化学习介绍   【PPT】 Human-level control through deep reinforcement learning  （DQN）</a>
			</li>
						<li><a href="https://www.batexi.com/a/960ezxn9.html">10&period;我们可以用2&ast;1的小矩形横着或者竖着去覆盖更大的矩形。  请问用n个2&ast;1的小矩形无重叠地覆盖一个2&ast;n的大矩形，总共有多少种方法？</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
